<script src="@#file#(webgl-math.js)" type="text/javascript"></script>
<script src="@#file#(webgl-basic.js)" type="text/javascript"></script>
<script src="@#file#(webgl-view.js)" type="text/javascript"></script>
<script src="@#file#(webgl-proj.js)" type="text/javascript"></script>
<script src="@#file#(osvj.js)" type="text/javascript"></script>

<script type="text/javascript">
  var ld1 = null;

  function start() {
    ld1 = new lightningDemo('myCanvas1', 4, 0);

    ld1.scene.toggleAmbient(true);
    ld1.scene.toggleDiffuze(true);
    ld1.scene.toggleSpecular(true);

    ld1.startAnimation();
  }
</script>

<p>
  Postupak konstantnog sjenčanja (u OpenGL-u poznat kao engl. <i>flat shading</i>) za čitav
  poligon unaprijed određuje jednu boju kojom će prilikom rasterizacije obojati <i>sve</i> 
  slikovne elemente. 
</p>

<p>
  Boja se može odrediti, npr. Phongovim modelom osvjetljavanja. Za izračun intenziteta svjetlosti
  koristi se normala poligona te vektor prema izvoru (ako je izvor usmjeren), ili pak normala
  poligona i vektor prema izvoru koji se za točkaste izvore računa kao razlika između položaja
  izvora i neke (jedne) točke poligona. U ovom scenariju najviše smisla ima uzeti centar poligona
  (aritmetičku sredinu svih vrhova).
</p>

<p>
  Jednom kad smo odredili boju, pokrećemo postupak rasterizacije i <i>sve</i> slikovne elemente
  koje treba osvijetliti, bojamo tom bojom. Ideja postupka prikazana je na slici 1.
</p>

<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(konst-p.svg)">
<figcaption>Slika 1. Konstantno sjenčanje. Boju određujemo u jednoj točki i potom sve slikovne elemente poligona bojamo tom bojom.</figcaption>
</figure>

<p>
  Opisani postupak sjenčanja koristi se u demonstraciji u nastavku. Oplošje kugle/elipsoida
  opisano je nizom poligona. Promatrač rotira oko scene.
</p>

  <canvas id="myCanvas1" width="640" height="480">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas>
  <p>
  &nbsp;
  </p>

<p>
  Primjetite kako izgledaju tijela. Svaki se poligon jasno vidi jer dva susjedna poligona (poligoni
  koji dijele brid) imaju izračunate ponešto drugačije boje, i ta se razlika jasno vidi na njihovom spoju.
</p>

<p>
  Primjetite također što se događa s prikazom odbljeska. Odbljesak izračunat u odabranoj točki poligona
  određuje boju koja se koristi pri bojanju čitavog poligona, što izgleda dosta neprirodno.
</p>

<p>
  Ovaj postupak računski je najučinkovitiji, no generira najmanje realistične scene.
</p>

<script type="text/javascript">
start();
</script>

